# WORKING MODEL MAY 2022
library(colorspace)
library(scales)
library(RColorBrewer)

coefz.p <- readRDS('FS_COEFS_dis.RDS')$COEFP
coefz.x <- readRDS('FS_COEFS_dis.RDS')$COEFX
data <- readRDS('DATUM.RDS')
simulation <- list(timelength = 500,
                   q_0 = 0.055,
                   tax = 0.05,
                   theta = .8,
                   gam = 0,
                   geo = 'DEU',
                   sector = 'C19')

timelength <- simulation$timelength
q_0 <- simulation$q_0
tax <- simulation$tax
theta <- simulation$theta
gam <- simulation$gam

subsidy<- T
tax_ation <- T
innovation <- T
TIO <- 5
zou <- simulation$geo
thesector <- simulation$sector
if(zou == 'JPN') {thesector <- 'D' } else {thesector <- 'C19'}
# 'B', 'C19', 'D'

dp <- coefz.p[zou,]
dx <- coefz.x[zou,]
seko <- dimnames(coefz.p)[[2]][dp>0 & dx>0]
seko <- seko[!is.na(seko)]
dp <- dp[seko]
dx <- dx[seko]
A <- data$io[zou,15,seko,seko]
q0 <- abs(Re(eigen(A)$vectors[,1]))
seko <- seko[ q0 != 0 ]
q0 <- q0[q0 != 0]
dp <- dp[seko]
dx <- dx[seko]
A <- A[seko,seko]
N <- K <- nrow(A)
Kmax <- K+1

p_0 <- abs(Re(t(eigen(t(A))$vectors[,1])))
lastyear <- 22
if(zou=='JPN' | zou=='ITA') lastyear<-21
p0 <- p_0 * data$p_go[zou, seko, lastyear] / rowMeans(data$p_go[zou, seko, ], na.rm=T)
x0 <- data$go_q[zou, seko, 15] / (q0 * mean(data$go_q[zou, seko, 15] / q0, na.rm = T))
Rt <- taxt <- Nt <- c()
Rt[1] <- sum(p0 * x0) / p0 %*% A %*% x0 # R <- R.[which(zou==dimnames(coefz.p)[[1]]),15]
Nt[1] <- N

taxt[1:TIO] <- 0
phaseout <- rep(NA, TIO)
labels <- c('k', 'p', 'X', paste0('a', 1:Kmax), paste0('b', 1:Kmax), 'M', 'r', 'pi', 'g')
capital <- array(0, 
                 dim=c(Kmax, length(labels), timelength), 
                 dimnames = list(paste0('K', 1:Kmax), labels, paste0('t', c(1:timelength))))
capital[1 : N, c('p', 'X'), 1] <- c(p0, x0)
capital[1 : N, paste0('a', 1:K), 1] <- t(A)
capital[1 : N, paste0('b', 1:K), 1] <- t(B <- diag(K))
capital[1 : N, 'k', 1] <- 1:K
capital[1 : N, 'M', 1] <- capital[1 : N, 'p', 1] %*% A * capital[1 : N, 'X', 1]
capital[1 : N, 'pi', 1] <- capital[1 : N, 'p', 1] * capital[1 : N, 'X', 1]
capital[1 : N, 'r', 1] <- capital[1 : N, 'p', 1] * t(B %*% capital[1 : N, 'X', 1]) / (capital[1 : N, 'p', 1] %*% A * capital[1 : N, 'X', 1]) - 1
  
for (t in 1: (timelength - 1))
{
    # INNOVATION
    if(t == TIO & innovation)
    {
      target <- which(capital[1 : N, 'k', t] == which(seko == thesector))
      capital[(target + 1) : (N + 1), , t] <- capital[target:N, , t]
      capital[target + 1, paste0('a', 1:K), t] <- theta * capital[target + 1, paste0('a', 1:K), t]
      capital[target + 1, 'X', t] <- q_0 * capital[target + 1, 'X', t]
      N <- N + 1
      sectors <- which(capital[1 : N, 'k', t] == which(seko == thesector))
    }
    A <- t(capital[1 : N, paste0('a', 1:K), t])
    B <- t(capital[1 : N, paste0('b', 1:K), t])
    C <- B - Rt[t] * A
    
    cnt <- sapply(lapply(1 : K, function(k) which(capital[, 'k', t] == k)), "[", 1)
    P <- t(capital[cnt, 'p', t])
    X <- t(t(capital[1 : N, 'X', t]))
    capital[1 : N, 'p', t + 1] <- (P - dp * P * t(C %*% X))[capital[1 : N, 'k', t]]
    s <- -t(C) %*% diag(dp * as.vector(P)) %*% C
    capital[1 : N, 'X', t + 1] <- X + dx[capital[1 : N, 'k', t]] * X * (t(C) %*% t(P) + gam * (s %*% X))
    
    Rt[t + 1] <- (P %*% B %*% X)/(P %*% A %*% X)
    Nt[t + 1] <- N
    capital[1 : N, paste0('a', 1:K), t + 1] <- t(A)
    capital[1 : N, paste0('b', 1:K), t + 1] <- t(B)
    capital[1 : N, 'k', t + 1] <- capital[1 : N, 'k', t]
    
    if(t>TIO & tax_ation)
    {
      taxation <- tax * capital[sectors[1], 'X', t + 1]
      taxt[t + 1] <- taxation
      capital[sectors[1], 'X', t + 1] <- capital[sectors[1], 'X', t + 1] - taxation
      if(subsidy) capital[sectors[2], 'X', t + 1] <- capital[sectors[2], 'X', t + 1] + taxation
    }
    
    capital[1 : N, 'M', t + 1] <- capital[cnt, 'p', t + 1] %*% A * capital[1 : N, 'X', t + 1]
    capital[1 : N, 'g', t] <- capital[1 : N, 'M', t + 1]/capital[1 : N, 'M', t]-1
    capital[1 : N, 'pi', t + 1] <- capital[1 : N, 'p', t + 1] * capital[1 : N, 'X', t + 1] # P * t(B %*% X)
    capital[1 : N, 'r', t + 1] <- capital[1 : N, 'p', t + 1] * capital[1 : N, 'X', t + 1]/(capital[cnt, 'p', t + 1] %*% A * capital[1 : N, 'X', t + 1]) - 1
    
    if(t > TIO & innovation) 
    { 
      phaseout[t] <- capital[sectors[2], 'X', t]/capital[sectors[1], 'X', t]
    }
}
capital[sectors[2], c('r', 'g'), TIO] <- NA
capital[ , 'g', 1] <- NA
capital[ , 'g', t + 1] <- capital[, 'M', t + 1]/capital[, 'M', t]-1
duration  <-  which(phaseout > 1)[which(which(phaseout > 1) > TIO)][1] - TIO

simulation$capital <- capital
simulation$duration <- duration