library(dplyr)
library(reshape2)
library(alabama)
dat<-readRDS('WIOD/Statistical_National-Accounts.rds')

kou<-c('DE','FR','IT','JP','NL','US')
sek<-unique(dat$code)
yrks<-unique(dat$year)
comp<-go_q<-va_q<-ii<-va<-ii_q<-p_go<-go<-array(NA,dim=c(length(kou),length(sek),length(yrks)),dimnames=list(kou,sek,yrks))

for (i in 1:length(kou))
{
  foo<-dcast(dat[dat$var=='GO' & dat$country==kou[i],], code ~ year, value.var="value")
  rownames(foo)<-foo$code
  go[kou[i],sek,colnames(foo[sek,-1])]<-as.matrix(foo[sek,-1])
  foo<-dcast(dat[dat$var=='GO_PI' & dat$country==kou[i],], code ~ year, value.var="value")
  rownames(foo)<-foo$code
  p_go[kou[i],sek,colnames(foo[sek,-1])]<-as.matrix(foo[sek,-1])
  foo<-dcast(dat[dat$var=='GO_Q' & dat$country==kou[i],], code ~ year, value.var="value")
  rownames(foo)<-foo$code
  go_q[kou[i],sek,colnames(foo[sek,-1])]<-as.matrix(foo[sek,-1])
  foo<-dcast(dat[dat$var=='VA_Q' & dat$country==kou[i],], code ~ year, value.var="value")
  rownames(foo)<-foo$code
  va_q[kou[i],sek,colnames(foo[sek,-1])]<-as.matrix(foo[sek,-1])
  foo<-dcast(dat[dat$var=='VA' & dat$country==kou[i],], code ~ year, value.var="value")
  rownames(foo)<-foo$code
  va[kou[i],sek,colnames(foo[sek,-1])]<-as.matrix(foo[sek,-1])
  foo<-dcast(dat[dat$var=='COMP' & dat$country==kou[i],], code ~ year, value.var="value")
  rownames(foo)<-foo$code
  comp[kou[i],sek,colnames(foo[sek,-1])]<-as.matrix(foo[sek,-1])
  foo<-dcast(dat[dat$var=='II' & dat$country==kou[i],], code ~ year, value.var="value")
  rownames(foo)<-foo$code
  ii[kou[i],sek,colnames(foo[sek,-1])]<-as.matrix(foo[sek,-1])
  foo<-dcast(dat[dat$var=='II_Q' & dat$country==kou[i],], code ~ year, value.var="value")
  rownames(foo)<-foo$code
  ii_q[kou[i],sek,colnames(foo[sek,-1])]<-as.matrix(foo[sek,-1])
}

dat<-readRDS('WIOD/Statistical_Growth-Accounts.rds')
cap<-lab<-array(NA,dim=c(length(kou),length(sek),length(yrks)),dimnames=list(kou,sek,yrks))
for (i in 1:length(kou))
{
  foo<-dcast(dat[dat$var=='CAP' & dat$country==kou[i],], code ~ year, value.var="value")
  rownames(foo)<-foo$code
  cap[kou[i],sek,colnames(foo[sek,-1])]<-as.matrix(foo[sek,-1])
  foo<-dcast(dat[dat$var=='LAB' & dat$country==kou[i],], code ~ year, value.var="value")
  rownames(foo)<-foo$code
  lab[kou[i],sek,colnames(foo[sek,-1])]<-as.matrix(foo[sek,-1])
}

r_agg<-R_<-array(NA,dim=c(length(kou),length(yrks)),dimnames=list(kou,yrks))
#r1<-array(NA,dim=c(length(kou),length(yrks)),dimnames=list(kou,yrks))
for(i in 1:length(kou)) 
{
  r_agg[kou[i],]<-cap[kou[i],'MARKT',]/(ii[kou[i],'MARKT',]+lab[kou[i],'MARKT',])
  R_[kou[i],]<-1+r_agg[kou[i],]
}
sekk0<-sek0
sekk0[which(sek0 %in% c('D35','L68','O84','P85'))]<-c('D','L','O','P')

foo<-go_q['DE',sekk0,'2000']-R_['DE','2000']*io['DEU','2000',,] %*% go_q['DE',sekk0,'2000']



plot(NA,xlim=c(min(go['DE',sekk0,yrs]),max(go['DE',sekk0,yrs])),ylim=c(min(GOK['DEU',sekk0,]),max(GOK['DEU',sekk0,])))
grid()
# for(i in sekk0) {points(go['DE',i,yrs],GOK['DEU',,i],pch=16,col=rainbow_hcl(length(sekk0))[which(i==sekk0)])}    
for(i in sekk0) {points(go['DE',i,yrs],GOK['DEU',i,],pch=16,col=rainbow_hcl(length(yrs)))}    
abline(a=0,b=1,lty=2)
mtext(c('EU KLEMS','WIOD'),side=c(1,2),line=2,cex=0.9)

GOK<-aperm(GOK,c(1,3,2))
plot(density(go['DE',sekk0,yrs]/GOK['DEU',,]))

foo<-melt(GOK['DEU',,]/go['DE',sekk0,yrs])
colnames(foo)[1:2]<-c('sec','year')
unique(foo$year[foo$value<1])
plot(density(foo$value[foo$value<1]))
plot(density(foo$value[foo$value>1]))

x<-go_q['FR',sekk0,yrs]
y<-sapply(yrs,function(t){R_['FR',t]*io['FRA',t,,sekk0] %*% go_q['FR',sekk0,t]})
plot(NA,xlim=c(min(x),max(x)),ylim=c(min(y),max(y)))
grid()
#for(i in 1:nrow(x)){points(x[i,],y[i,],col=rainbow_hcl(ncol(x)),pch=16)}
for(i in 1:nrow(x)){points(x[i,],y[i,],col=rainbow_hcl(nrow(x))[i],pch=16)}
abline(a=0,b=1,lty=2)
rownames(x)<-rownames(y)<-sekk0
points(x[unique(foo$Var1[foo$value<0.01]),],y[unique(foo$Var1[foo$value<0.01]),])
# points(x[c('A','H52','H53'),],y[c('A','H52','H53'),])
mtext(c('Supply','Demand'),side=c(1,2),line=2,cex=0.9)

foo<-y/x
rownames(foo)<-sekk0
foo<-melt(foo)
unique(foo$Var1[foo$value<0.01])
plot(density(va['DE',sekk0,yrs]-lab['DE',sekk0,yrs]-cap['DE',sekk0,yrs]))
plot(density(go['DE',sekk0,yrs]-va['DE',sekk0,yrs]-ii['DE',sekk0,yrs]))
x<-va['DE',sekk0,yrs]-comp['DE',sekk0,yrs]
y<-ii['DE',sekk0,yrs]+comp['DE',sekk0,yrs]
plot(NA,xlim=c(min(x),max(x)),ylim=c(min(y),max(y)))
grid()
#for(i in 1:nrow(x)){points(x[i,],y[i,],col=rainbow_hcl(ncol(x)),pch=16)}
for(i in 1:nrow(x)){points(x[i,],y[i,],col=rainbow_hcl(nrow(x))[i],pch=16)}
abline(a=0,b=1,lty=2)
mtext(c('Revenue','Cost'),side=c(1,2),line=2,cex=0.9)
rownames(x)<-rownames(y)<-sekk0
points(x[unique(foo$Var1[foo$value<0.01]),],y[unique(foo$Var1[foo$value<0.01]),])
# points(x[c('A','H52','H53'),],y[c('A','H52','H53'),])

plot(va['DE',sekk0,yrs]-comp['DE',sekk0,yrs],R_['DE',yrs]*ii['DE',sekk0,yrs])
abline(a=0,b=1,lty=2)

coefs<-matrix(NA,nrow=length(yrs),ncol=4)
plot(ii['DE',sekk0[!sekk0 %in% c('M_N','L')],yrs],-va['DE',sekk0[!sekk0 %in% c('M_N','L')],yrs]+go['DE',sekk0[!sekk0 %in% c('M_N','L')],yrs])
va['DE',sekk0[!sekk0 %in% c('M_N','L')],yrs]/ii['DE',sekk0[!sekk0 %in% c('M_N','L')],yrs]
plot(comp['DE',sekk0[!sekk0 %in% c('M_N','L')],yrs],va['DE',sekk0[!sekk0 %in% c('M_N','L')],yrs])
for(t in 1:length(yrs))
{
  points(comp['DE',sekk0[!sekk0 %in% c('M_N','L')],yrs[t]],va['DE',sekk0[!sekk0 %in% c('M_N','L')],yrs[t]],pch=16,col=rainbow_hcl(length(yrs))[t])
  fit<-lm(as.vector(va['DE',sekk0[!sekk0 %in% c('M_N','L')],yrs[t]]) ~ as.vector(comp['DE',sekk0[!sekk0 %in% c('M_N','L')],yrs[t]]))
  coefs[t,]<-as.vector(summary(fit)$coefficients[1:2,c(1,4)])
}
fit<-lm(as.vector(va['DE',sekk0[!sekk0 %in% c('M_N','L')],yrs]) ~ as.vector(comp['DE',sekk0[!sekk0 %in% c('M_N','L')],yrs]))
summary(fit)

x<-melt(va['DE',sekk0,yrs]-comp['DE',sekk0,yrs])
y<-melt(ii['DE',sekk0,yrs]+comp['DE',sekk0,yrs])
colnames(x)<-colnames(y)<-c('sec','year','value')


x<-x[x$sec!='M_N' & x$sec!='L',]
y<-y[y$sec!='M_N' & y$sec!='L',]
plot(NA,xlim=c(min(x$value),max(x$value)),ylim=c(min(y$value),max(y$value)))
grid()
points(x$value,y$value,col=rainbow_hcl(length(unique(x$sec))),pch=16)
fit<-lm(y$value ~ x$value)
abline(fit,lty=2)

plot(comp['DE',,]+cap['DE',])
plot(comp['DE',,]+cap['DE',,],va['DE',,])

