# FLASCHEL-SEMMLER MODEL WITH 2 INDUSTRIES
# WITH ADJUSTMENT TO STABILIZE THE OSCILLATIONS
library(colorspace)
library(scales)
library(RColorBrewer)
timelength<-1000
#A<-matrix(c(0.625,0.2,0.8,0.05),nrow=2)
#A<-matrix(c(0.1,0.4,0,0.3,0,0.1,0.2,0.5,0.3,0.2,0.3,0,0.1,0.1,0.5,0.1),nrow=4)
A<-matrix(c(.2008,.001,.0034,.1247,.0855,.0897,.0093,0,.0658,.0002,.0684,.0529,.1668,.0129,.0011,.0035,.0012,.1801,.0914,.1332,.0095,.0338,.0219,.0021,.2319,.0952,.1255,.0197,.0001,.0151,.0035,.0339,.0645,.1647,.019,.0018,.0001,.0071,.0414,.0315,.2712,.0184,.0009,.0026,.0214,.0726,.0528,.1873,.0228),nrow=7)
#A<-A0
#A<-W
K<-nrow(A)
e0<-eigen(A)$values[1]
r_eq<-r0<-Re(1/eigen(A)$values[1]-1)
q0<-Re(eigen(A)$vectors[,1])
leontief<-solve(diag(K)-A)
y0<-t(t(q0)) # Final Demand
#dx<-rep(1,K)
#dp<-rep(0.005,K)
dx<-rep(0.05,K) # for 7-industry Miller
dp<-rep(0.01,K) # for 7-industry Miller
dx<-c(0.1,2,0.5,0.2)
dp<-rep(0.001,K)
#dx<-rep(0.1,K)
#dp<-rep(0.01,K)
gam<-1
x0<-leontief %*% y0 # Input Vector # (A %*% p0) capital/output p0 %*% A
p0<-Re(t(eigen(t(A))$vectors[,1]))
# x0<-c(0.45,0.4)
# p0<-c(0.6,0.6)
# (diag(K)-R*A) %*% x0 should be zero?
R<-1+r_eq

# INITIALIZATION
labels<-c('M','k',paste0('a',1:K),'p','r','X','S','D','pi','K','g')
K<-nrow(A)
capital<-array(0,dim=c(K,length(labels),timelength),dimnames=list(paste0('K',c(1:K)),labels,paste0('t',c(1:timelength))))

capital[,c('p','X'),1]<-c(p0,x0)
capital[,paste0('a',1:K),1]<-A
capital[,'X',1]<-(x0 + 5*rep(c(.1,-.1),K)[1:K])*rnorm(K,1,0.06)
capital[,'p',1]<-(p0 - 0.01*rep(c(.1,-.1),K)[1:K])*rnorm(K,1,0.06)
capital[,'M',1]<-capital[,'p',1] %*% A * capital[,'X',1]
capital[,c('pi','g'),1]<-NA
capital[,'r',1]<-capital[,'p',1]*capital[,'X',1]/(capital[,'p',1] %*% A * capital[,'X',1])-1

for (t in 1:(timelength-1))
{
  capital[,'p',t+1]<-capital[,'p',t]-dp*t((diag(K)-R*A) %*% t(t(capital[,'X',t])))*capital[,'p',t]
  s<-t(diag(K)-R*A) %*% t(t(capital[,'p',t+1]-capital[,'p',t]))
  capital[,'X',t+1]<-capital[,'X',t]+dx*(t(diag(K)-R*A) %*% t(t(capital[,'p',t]))+gam*s)*capital[,'X',t]
  
  
  capital[,'S',t+1]<-t((diag(K)-R*A) %*% t(t(capital[,'X',t])))
  capital[,'D',t+1]<-t(diag(K)-R*A) %*% t(t(capital[,'p',t]))+gam*s
  capital[,'M',t+1]<-capital[,'p',t] %*% A * capital[,'X',t+1]
  capital[,'g',t]<-capital[,'M',t+1]/capital[,'M',t]-1
  capital[,'pi',t+1]<-capital[,'p',t+1]*capital[,'X',t+1]
  capital[,'K',t+1]<-capital[,'M',t+1]/capital[,'X',t+1]
  capital[,'r',t+1]<-capital[,'p',t]*capital[,'X',t]/(capital[,'p',t] %*% A * capital[,'X',t])-1
}

# capital[,'g',1]<-NA
colores<-rainbow_hcl(K)
lab_<-c('price (p)','output (X)','matrixp (S)','matrixX (D)','profit rate (r)', 'growth (g)')
names(lab_)<-c('p','X','S','D','r','g')
tval<-1:1000
#tval<-1:timelength
par(mfrow=c(2,3),mar=c(3, 2.7, 1.6, 1.4),oma=c(0,0,0,0))
for(lab in names(lab_))
{
  yli<-c(min(Re(capital[,lab,tval]),na.rm=T),max(Re(capital[,lab,tval]),na.rm=T))
  # yli<-c(min(avg[,lab,tval],na.rm=T),max(avg[,lab,tval],na.rm=T))
  if(lab=='x'){yli[1]<-0}
  #if(lab=='p'){yli[1]<-4}
  plot(NA,xlim=c(min(tval),max(tval)),ylim=yli,xlab='',ylab='',main=lab_[lab],font.lab=2,cex.lab=1)
  grid()
  #if(lab=='r' | lab=='p'){for(i in 1:N){points(tval,capital[i,lab,tval],col=alpha(colori[N-i+1],0.25),cex=0.8,pch=16)}} else{for(i in 1:N){lines(tval,capital[i,lab,tval],col=alpha(colori[N-i+1],0.25),lwd=2)}}
  for(k in 1:K){lines(tval,capital[k,lab,tval],col=colores[k],lwd=2.25)}
  # if(lab=='x'){for(k in 1:K){lines(tval,yli[2]*N_h[tval,k]/N,col=rgb(t(col2rgb(colores[k])/1.4),maxColorValue=255),lwd=1.9,lty=3)}}
  # if(lab=='x'){axis(4,at=seq(0,yli[2],length.out=5),labels=seq(0,yli[2],length.out=5)*N/yli[2])}
  #if(lab=='p'){for(k in 1:K){lines(tval,p0[k,tval],col='black',lwd=0.8,lty=2)}}
  if(lab=='p'){abline(h=p0,col='black',lwd=0.8,lty=2)}
  if(lab=='p'){mtext(paste0('p',1:K),side=4,at=p0,las=1,cex=0.8,font=2)}
  if(lab=='X'){abline(h=x0,col='black',lwd=0.8,lty=2)}
  if(lab=='X'){mtext(paste0('X',1:K),side=4,at=x0,las=1,cex=0.8,font=2)}
  if(lab=='r'){abline(h=r_eq,lty=2)}
  legend('topleft',paste0('K',1:K),col=colores,pch=16,pt.cex=2,cex=0.9,bty='n')
  mtext('time',side=1,cex=0.8,line=2,font=2)
}

# k<-1
# plot(capital[k,'r',],capital[k,'g',],type='l',col='white')
# points(capital[k,'r',2],capital[k,'g',2],col='white')
# for(k in 1:1){
# lines(capital[k,'r',],capital[k,'g',],col=colores[k],lwd=1.5)
# points(capital[k,'r',2],capital[k,'g',2],col=colores[k])}